#property copyright ""
#property link      ""
 
//Propriete de l'expert
extern int     MagicNumber = 1;
extern string  Commentaire = "_";
extern int     TakeProfit=20;
extern int     StopLoss=100;
extern double  FirstLots=0.1;
extern double  MaximumLots=10;
extern bool    OpenBuy=true;
extern double  LotsDouble=2;
extern int     Slippage=5;
int    Ticket1,Ticket2;
int hour;
extern int   StartTime = 0;
extern int   EndTime   = 23;
int    t1,t2,gT1,gT2;
int handle;
string setup;
int init()
{
  Comment("");
  return(0);
}
int deinit()
{
  Comment("");
  return(0);
}
int start()
{
  hour = TimeHour(CurTime());
  Procces_1();
  return(0);
}

//****************************************************************************************************************  
// La fonction pour ovrir une ordre d'achat et ses multiples si necessaire
void OpenBUYOrder(double Lots,int Magic)
{
   double sl,tp;
   setup=MagicNumber + Commentaire;
 
   sl=Ask-StopLoss*Point;
   tp=Ask+TakeProfit*Point;
   if (Lots==FirstLots && Lots<=MaximumLots && hour>=StartTime && hour<=EndTime)
   {
     Ticket1=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,sl,tp,setup,Magic,0,Green);
     if(Ticket1>0)
     {
       gT1=OrderSend(Symbol(),OP_SELLSTOP,Lots*LotsDouble,sl,Slippage,sl+StopLoss*Point,sl-TakeProfit*Point,setup,Magic,0,Green);
     }
     else
     {
      Alert("Erreur d'achat"," Err = ",GetLastError()," Price = ",Ask," Lots = ",Lots);
     }
   }
}
// La fonction pour ovrir une ordre de vente et ses multiples si necessaire
void OpenSELLOrder(double Lots,int Magic)
{
   double sl,tp;
   setup=MagicNumber + Commentaire;
    
   sl=Bid+StopLoss*Point;
   tp=Bid-TakeProfit*Point;
   if (Lots==FirstLots && Lots<=MaximumLots && hour>=StartTime && hour<=EndTime)
   {
     Ticket1=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,sl,tp,setup,Magic,0,Red);
     if(Ticket1>0)
     {
       gT1=OrderSend(Symbol(),OP_BUYSTOP,Lots*LotsDouble,sl,Slippage,sl-StopLoss*Point,sl+TakeProfit*Point,setup,Magic,0,Green);
     }
     else
     {
       Alert("Erreur de vente "," Err = ",GetLastError()," Price = ",Bid," Lots = ",Lots);
     }
   }
}
// La fonction principale
int Procces_1()
{
  double slot,ssl,stp,bw;
// S'il n y a pas d'ordres actuels mais reste des pending ordres. nous allons les supprimer 
  if (MyRealOrdersTotal(MagicNumber)==0 && MyPendingOrdersTotal(MagicNumber)>0)
  {
    DeletePendingOrders(MagicNumber);
    return(0);
  }
// Si pas d'ordre actuellement, nous allons en ouvrir dans le sens choisi par l'utilisateur
  if (MyRealOrdersTotal(MagicNumber)==0 && MyPendingOrdersTotal(MagicNumber)==0 && slot<=MaximumLots && hour>=StartTime && hour<=EndTime)
  {
    if (OpenBuy && slot<=MaximumLots)
    {
      OpenBUYOrder(FirstLots,MagicNumber);
    }
    else
    {
      OpenSELLOrder(FirstLots,MagicNumber);
    }
    return(0);
  }
// Si on a ouvert des positions, nous allons preparer des ordres suspendues dans le sens inverse
  if (MyRealOrdersTotal(MagicNumber)==1 && MyPendingOrdersTotal(MagicNumber)==0 && slot<=MaximumLots)
  {
    OrderSelect(t1,SELECT_BY_TICKET,MODE_TRADES);
    slot=OrderLots()*LotsDouble;
    ssl=OrderStopLoss();
    stp=OrderTakeProfit();
 
    if (OrderType()==OP_BUY && slot<=MaximumLots)
    {
       gT1=OrderSend(Symbol(),OP_SELLSTOP,slot,ssl,Slippage,ssl+StopLoss*Point,ssl-TakeProfit*Point,setup,MagicNumber,0,Green);
    }
    if (OrderType()==OP_SELL && slot<=MaximumLots)
    {
       gT1=OrderSend(Symbol(),OP_BUYSTOP,slot,ssl,Slippage,ssl-StopLoss*Point,ssl+TakeProfit*Point,setup,MagicNumber,0,Green);
    }
 
  }
  return(0);
}
// Une fonction pour calculer le nombre des positions actuelles
int MyRealOrdersTotal(int Magic)
{
  int c=0;
  int total  = OrdersTotal();
  t1=-1;
  t2=-1;
 
  for (int cnt = 0 ; cnt < total ; cnt++)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if (OrderMagicNumber() == Magic && OrderSymbol()==Symbol() && (OrderType()==OP_BUY || OrderType()==OP_SELL))
    {
      if (t1==-1)
      {
        t1=OrderTicket();
      }
      else
      {
        if (t2==-1)
        {
          t2=OrderTicket();
        }
      }
      c++;
    }
  }
  return(c);
}
// Une fonction pour calculer uniquement le nombre des positions suspendues
int MyPendingOrdersTotal(int Magic)
{
  int c=0;
  int total  = OrdersTotal();
 
  for (int cnt = 0 ; cnt < total ; cnt++)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if (OrderMagicNumber() == Magic && OrderSymbol()==Symbol() && (OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP))
    {
      c++;
    }
  }
  return(c);
}
// Une fonction pour supprimer les positions suspendues
int DeletePendingOrders(int Magic)
{
int total  = OrdersTotal();
 
for (int cnt = total - 1; cnt >= 0; cnt--)
{
 OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
 if (OrderMagicNumber() == Magic && OrderSymbol()==Symbol() && (OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP))
 {
   OrderDelete(OrderTicket());
 }
}
return(0);
}